## deepin-terminal 5.4.28

=== CMakeLists.txt ===
project(deepin-terminal)

cmake_minimum_required(VERSION 3.9.5)

list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_LIST_DIR})

include (src/DtkSettingsToolsMacros)
option(TERM_RPATH "Do you want to use compiled libraries" ON)

if(TERM_RPATH)
set(CMAKE_SKIP_INSTALL_RPATH YES)
set(CMAKE_SKIP_RPATH YES)
endif()

set(CMAKE_C_STANDARD 11)
set(CMAKE_C_STANDARD_REQUIRED ON)
set(CMAKE_CXX_STANDARD 11)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)

set(QT_MINIMUM_VERSION "5.7.1")

if (${CMAKE_SYSTEM_PROCESSOR} MATCHES "sw_64")
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -mieee")
endif ()

#compile flags
if (CMAKE_BUILD_TYPE MATCHES Debug)
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -Wextra")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -Wextra")

  # Enable Qt builtin debug mode
  add_definitions("-DQT_MESSAGELOGCONTEXT")
else()
  # -Wl, -O2 Enable linker optimizations
  # -Wl, --gc-sections
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wall -O2 -Wl,-O1 -Wl,--gc-sections")
endif()

#Use deepin-turbo for Performance optimization
set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wl,--as-need -fPIE")
set(CMAKE_EXE_LINKER_FLAGS "-pie")
#安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

configure_file(src/environments.h.in environments.h @ONLY)

# Find the QtWidgets library

find_package(PkgConfig REQUIRED)
find_package(Qt5Core REQUIRED)
find_package(Qt5DBus REQUIRED)
find_package(Qt5Gui REQUIRED)
find_package(Qt5Widgets REQUIRED)
find_package(Qt5LinguistTools REQUIRED)
find_package(Qt5Network REQUIRED)
find_package(Qt5X11Extras REQUIRED)
#find_package(DtkWidget REQUIRED)
#find_package(DtkCore REQUIRED)
#find_package(DtkGui REQUIRED)

include(FindPkgConfig)

pkg_search_module(DtkWidget REQUIRED dtkwidget)
pkg_search_module(DtkGui REQUIRED dtkgui)
pkg_search_module(DtkCore REQUIRED dtkcore)
pkg_search_module(GOBJECT REQUIRED gobject-2.0)
pkg_check_modules(DFrameworkDBus REQUIRED dframeworkdbus)
pkg_check_modules(LIBSECRET REQUIRED libsecret-1)
pkg_check_modules(XCB_EWMH REQUIRED xcb-ewmh x11)


# Compile definitions for TerminalWidget
# So we can use QT_VERSION_CHECK
set(TERMINALWIDGET_VERSION_MAJOR "0")
set(TERMINALWIDGET_VERSION_MINOR "14")
set(TERMINALWIDGET_VERSION_PATCH "1")

add_subdirectory(3rdparty/terminalwidget)

include_directories(${DtkWidget_INCLUDE_DIRS})
include_directories(${DtkGui_INCLUDE_DIRS})
include_directories(${DtkCore_INCLUDE_DIRS})

include_directories("src/common")
include_directories("src/customcommand")
include_directories("src/encodeplugin")
include_directories("src/main")
include_directories("src/remotemanage")
include_directories("src/settings")
include_directories("src/views")
include_directories("3rdparty/terminalwidget/lib")

set(LINK_LIBS
    Qt5::Core
    Qt5::DBus
    Qt5::Widgets
    Qt5::WidgetsPrivate
    Qt5::Network

    ${DtkWidget_LIBRARIES}
    ${DtkCore_LIBRARIES}
    ${DtkGUI_LIBRARIES}
    ${DFrameworkDBus_LIBRARIES}
    ${GOBJECT_LIBRARIES}
    ${LIBSECRET_LIBRARIES}
    ${XCB_EWMH_LIBRARIES}
    ${Qt5X11Extras_LIBRARIES}
)

# Populate a CMake variable with the sources
# TODO: portable headers?
set (DTNG_CPP_FILES
    src/common/utils.cpp
    src/common/settingio.cpp
    src/customcommand/customcommandoptdlg.cpp
    src/customcommand/customcommandpanel.cpp
    src/customcommand/customcommandplugin.cpp
    src/customcommand/customcommandsearchrstpanel.cpp
    src/customcommand/customcommandtoppanel.cpp
    src/encodeplugin/encodepanelplugin.cpp
    src/encodeplugin/encodepanel.cpp
    src/encodeplugin/encodelistview.cpp
    src/encodeplugin/encodelistmodel.cpp
    src/main/main.cpp
    src/main/service.cpp
    src/main/windowsmanager.cpp
    src/main/mainwindow.cpp
    src/main/terminalapplication.cpp
    src/main/termproperties.cpp    
    src/main/dbusmanager.cpp
    src/remotemanage/remotemanagementpanel.cpp
    src/remotemanage/remotemanagementplugn.cpp
    src/remotemanage/remotemanagementsearchpanel.cpp
    src/remotemanage/remotemanagementtoppanel.cpp
    src/remotemanage/serverconfiggrouppanel.cpp
    src/remotemanage/serverconfigmanager.cpp
    src/remotemanage/serverconfigoptdlg.cpp
    src/settings/newdspinbox.cpp
    src/settings/settings.cpp
    src/settings/settings_translation.cpp
    src/settings/shortcutmanager.cpp
    src/views/commonpanel.cpp
    src/views/pagesearchbar.cpp
    src/views/rightpanel.cpp
    src/views/tabbar.cpp
    src/views/tabrenamedlg.cpp
    src/views/tabrenamewidget.cpp
    src/views/termwidget.cpp
    src/views/termwidgetpage.cpp
    src/views/termbasedialog.cpp
    src/views/termcommandlinkbutton.cpp
    src/views/titlebar.cpp
    src/views/itemwidget.cpp
    src/views/focusframe.cpp
    src/views/iconbutton.cpp
    src/views/listview.cpp
    src/views/customthemesettingdialog.cpp
    src/views/themepreviewarea.cpp
)

set (DTNG_HEADER_FILES
    src/common/define.h
    src/common/utils.h
    src/common/settingio.h
    src/customcommand/customcommandoptdlg.h
    src/customcommand/customcommandpanel.h
    src/customcommand/customcommandplugin.h
    src/customcommand/customcommandsearchrstpanel.h
    src/customcommand/customcommandtoppanel.h
    src/encodeplugin/encodepanelplugin.h
    src/encodeplugin/encodepanel.h
    src/encodeplugin/encodelistview.h
    src/encodeplugin/encodelistmodel.h
    src/main/windowsmanager.h
    src/main/mainwindow.h
    src/main/mainwindowplugininterface.h
    src/main/service.h
    src/main/terminalapplication.h
    src/main/termproperties.h
    src/main/dbusmanager.h
    src/remotemanage/remotemanagementpanel.h
    src/remotemanage/remotemanagementplugn.h
    src/remotemanage/remotemanagementsearchpanel.h
    src/remotemanage/remotemanagementtoppanel.h
    src/remotemanage/serverconfiggrouppanel.h
    src/remotemanage/serverconfigmanager.h
    src/remotemanage/serverconfigoptdlg.h
    src/settings/newdspinbox.h
    src/settings/settings.h
    src/settings/shortcutmanager.h
    src/views/commonpanel.h
    src/views/pagesearchbar.h
    src/views/rightpanel.h
    src/views/tabbar.h
    src/views/tabrenamedlg.h
    src/views/tabrenamewidget.h
    src/views/termwidget.h
    src/views/termwidgetpage.h
    src/views/titlebar.h
    src/views/termbasedialog.h
    src/views/termcommandlinkbutton.h
    src/views/itemwidget.h
    src/views/focusframe.h
    src/views/iconbutton.h
    src/views/listview.h
    src/views/customthemesettingdialog.h
    src/views/themepreviewarea.h
)

set (DTNG_QRC_FILES
    src/assets/resources.qrc
)

# Program
set (EXE_NAME deepin-terminal)

# Translation
file (GLOB DTNG_TS_FILES translations/*.ts)
set (DTNG_CPP_FILES_FOR_I18N ${DTNG_CPP_FILES})

dtk_create_i18n_from_json(DTNG_SETTINGS_I18N_FILES default-config.json settings_translation.cpp)
list (APPEND DTNG_CPP_FILES_FOR_I18N ${DTNG_SETTINGS_I18N_FILES})
qt5_create_translation(DTNG_QM_FILES ${DTNG_CPP_FILES_FOR_I18N} ${DTNG_TS_FILES})

add_executable (${EXE_NAME}
    ${DTNG_HEADER_FILES}
    ${DTNG_CPP_FILES}
    ${DTNG_QRC_FILES}
    ${DTNG_QM_FILES}
)

target_include_directories(${EXE_NAME} PUBLIC ${Qt5Widgets_LIBRARIES}
                                              ${Qt5DBus_LIBRARIES}
                                              ${Qt5Widgets_PRIVATE_INCLUDE_DIRS}
                                              ${Qt5Core_PRIVATE_INCLUDE_DIRS}
                                              ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
                                              ${PROJECT_BINARY_DIR}
                                              ${DtkWidget_INCLUDE_DIRS}
                                              ${DtkCore_LIBRARIES}
                                              ${DtkGUI_INCLUDE_DIRS}
                                              ${DFrameworkDBus_INCLUDE_DIRS}
                                              ${ATSPI2_INCLUDE_DIRS}
                                              ${GOBJECT_INCLUDE_DIRS}
                                              ${LIBSECRET_INCLUDE_DIRS}
                                              ${XCB_EWMH_INCLUDE_DIRS})

target_link_libraries (deepin-terminal ${LINK_LIBS} terminalwidget5)

# Install settings

if (CMAKE_INSTALL_PREFIX_INITIALIZED_TO_DEFAULT)
    set(CMAKE_INSTALL_PREFIX /usr)
endif ()

# Installation

#install(TARGETS deepin-terminal DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-terminal)

install(FILES src/deepin-terminal.desktop
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/applications/)

install(FILES src/assets/logo/deepin-terminal.svg
        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/icons/hicolor/scalable/apps/)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/deepin-terminal
        DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
        PERMISSIONS OWNER_READ OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE)

install(FILES ${DTNG_QM_FILES} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-terminal/translations)

install(DIRECTORY src/assets/deepin-terminal
        DESTINATION /usr/share/deepin-manual/manual-assets/application/)

# Unit Test
add_subdirectory(tests)

=== 3rdparty/terminalwidget/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0 FATAL_ERROR)
# CMP0000: Call the cmake_minimum_required() command at the beginning of the top-level
# CMakeLists.txt file even before calling the project() command.
# The cmake_minimum_required(VERSION) command implicitly invokes the cmake_policy(VERSION)
# command to specify that the current project code is written for the given range of CMake
# versions.
project(terminalwidget)

include(GNUInstallDirs)
include(GenerateExportHeader)
include(CMakePackageConfigHelpers)
include(CheckFunctionExists)
include(CheckIncludeFile)

option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
option(BUILD_EXAMPLE "Build example application. Default OFF." OFF)
option(TERMINALWIDGET_USE_UTEMPTER "Uses the libutempter library. Mainly for FreeBSD" OFF)
option(TERMINALWIDGET_BUILD_PYTHON_BINDING "Build python binding" OFF)
option(USE_UTF8PROC "Use libutf8proc for better Unicode support. Default OFF" OFF)


# just change version for releases
set(TERMINALWIDGET_VERSION_MAJOR "0")
set(TERMINALWIDGET_VERSION_MINOR "14")
set(TERMINALWIDGET_VERSION_PATCH "1")

set(TERMINALWIDGET_VERSION "${TERMINALWIDGET_VERSION_MAJOR}.${TERMINALWIDGET_VERSION_MINOR}.${TERMINALWIDGET_VERSION_PATCH}")

# additional cmake files
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
set(CMAKE_INCLUDE_CURRENT_DIR ON)

set(CMAKE_INSTALL_PREFIX "/usr")

# Minimum Versions
set(QT_MINIMUM_VERSION "5.7.1")
set(LXQTBT_MINIMUM_VERSION "0.6.0")

find_package(Qt5Widgets "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(Qt5LinguistTools "${QT_MINIMUM_VERSION}" REQUIRED)
find_package(lxqt-build-tools ${LXQTBT_MINIMUM_VERSION} REQUIRED)

if(USE_UTF8PROC)
    find_package(Utf8Proc REQUIRED)
endif()

#注释掉下面这行，否则无法支持命令行cmake构建
#include(LXQtPreventInSourceBuilds)
include(LXQtTranslateTs)
include(LXQtCompilerSettings NO_POLICY_SCOPE)
include(LXQtCreatePkgConfigFile)

if(APPLE)
    if(CMAKE_VERSION VERSION_GREATER 3.9)
        cmake_policy(SET CMP0068 NEW)
        set(CMAKE_BUILD_WITH_INSTALL_NAME_DIR ON)
    endif()
endif()

set(TERMINALWIDGET_LIBRARY_NAME terminalwidget5)

remove_definitions(-DQT_NO_CAST_FROM_ASCII -DQT_NO_CAST_TO_ASCII -DQT_NO_CAST_FROM_BYTEARRAY)

# main library

set(SRCS
    lib/BlockArray.cpp
    lib/ColorScheme.cpp
    lib/CharacterFormat.cpp
    lib/Emulation.cpp
    lib/Filter.cpp
    lib/history/HistoryFile.cpp
    lib/history/HistoryScroll.cpp
    lib/history/HistoryScrollFile.cpp
    lib/history/HistoryScrollNone.cpp
    lib/history/HistoryType.cpp
    lib/history/HistoryTypeFile.cpp
    lib/history/HistoryTypeNone.cpp
    lib/history/compact/CompactHistoryBlock.cpp
    lib/history/compact/CompactHistoryBlockList.cpp
    lib/history/compact/CompactHistoryLine.cpp
    lib/history/compact/CompactHistoryScroll.cpp
    lib/history/compact/CompactHistoryType.cpp
    lib/HistorySearch.cpp
    lib/KeyboardTranslator.cpp
    lib/konsole_wcwidth.cpp
    lib/kprocess.cpp
    lib/kpty.cpp
    lib/kptydevice.cpp
    lib/kptyprocess.cpp
    lib/ProcessInfo.cpp
    lib/Pty.cpp
    lib/qtermwidget.cpp
    lib/Screen.cpp
    lib/ScreenWindow.cpp
    lib/SearchBar.cpp
    lib/Session.cpp
    lib/SessionManager.cpp
    lib/ShellCommand.cpp
    lib/TerminalCharacterDecoder.cpp
    lib/TerminalDisplay.cpp
    lib/tools.cpp
    lib/Vt102Emulation.cpp
)

# Only the Headers that need to be moc'd go here
set(HDRS
    lib/Emulation.h
    lib/Filter.h
    lib/history/HistoryFile.h
    lib/history/HistoryScroll.h
    lib/history/HistoryScrollFile.h
    lib/history/HistoryScrollNone.h
    lib/history/HistoryType.h
    lib/history/HistoryTypeFile.h
    lib/history/HistoryTypeNone.h
    lib/history/compact/CompactHistoryBlock.h
    lib/history/compact/CompactHistoryBlockList.h
    lib/history/compact/CompactHistoryLine.h
    lib/history/compact/CompactHistoryScroll.h
    lib/history/compact/CompactHistoryType.h
    lib/HistorySearch.h
    lib/kprocess.h
    lib/kptydevice.h
    lib/kptyprocess.h
    lib/ProcessInfo.h
    lib/Pty.h
    lib/qtermwidget.h
    lib/ScreenWindow.h
    lib/SearchBar.h
    lib/Session.h
    lib/SessionManager.h
    lib/TerminalDisplay.h
    lib/Vt102Emulation.h
)

set(UI
    lib/SearchBar.ui
)

# for distribution
set(HDRS_DISTRIB
    lib/qtermwidget.h
    lib/Emulation.h
    lib/Filter.h
    lib/Session.h
    lib/SessionManager.h
    lib/history/HistoryFile.h
    lib/history/HistoryScroll.h
    lib/history/HistoryScrollFile.h
    lib/history/HistoryScrollNone.h
    lib/history/HistoryType.h
    lib/history/HistoryTypeFile.h
    lib/history/HistoryTypeNone.h
    lib/history/compact/CompactHistoryBlock.h
    lib/history/compact/CompactHistoryBlockList.h
    lib/history/compact/CompactHistoryLine.h
    lib/history/compact/CompactHistoryScroll.h
    lib/history/compact/CompactHistoryType.h
    lib/BlockArray.h
    lib/Character.h
    lib/CharacterColor.h
    lib/TerminalDisplay.h
)

# dirs
set(KB_LAYOUT_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/kb-layouts")
message(STATUS "Keyboard layouts will be installed in: ${KB_LAYOUT_DIR}")

set(COLORSCHEMES_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/color-schemes")
message(STATUS "Color schemes will be installed in: ${COLORSCHEMES_DIR}" )

set(TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/translations")
message(STATUS "Translations will be installed in: ${TRANSLATIONS_DIR}")

set(TERMINALWIDGET_INCLUDE_DIR "${CMAKE_INSTALL_FULL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}")

CHECK_FUNCTION_EXISTS(updwtmpx HAVE_UPDWTMPX)

qt5_wrap_cpp(MOCS ${HDRS})
qt5_wrap_ui(UI_SRCS ${UI})
set(PKG_CONFIG_REQ "Qt5Widgets")

lxqt_translate_ts(TERMINALWIDGET_QM
    TRANSLATION_DIR "lib/translations"
    UPDATE_TRANSLATIONS
        ${UPDATE_TRANSLATIONS}
    SOURCES
        ${SRCS} ${HDRS} ${UI}
    INSTALL_DIR
        ${TRANSLATIONS_DIR}
    COMPONENT
        Runtime
)

add_library(${TERMINALWIDGET_LIBRARY_NAME} SHARED ${SRCS} ${MOCS} ${UI_SRCS} ${TERMINALWIDGET_QM})
target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME} Qt5::Widgets)
if (USE_TEST)
    #仅在单元测试模式下设置fvisibility为default
    target_compile_options(${TERMINALWIDGET_LIBRARY_NAME} PUBLIC "-fvisibility=default")
endif()
set_target_properties( ${TERMINALWIDGET_LIBRARY_NAME} PROPERTIES
                       SOVERSION ${TERMINALWIDGET_VERSION_MAJOR}
                       VERSION ${TERMINALWIDGET_VERSION}
                     )


if(APPLE)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTMPX"
            "UTMPX_COMPAT"
    )
endif()

if(HAVE_UPDWTMPX)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UPDWTMPX"
    )
endif()

if (TERMINALWIDGET_USE_UTEMPTER)
    CHECK_INCLUDE_FILE(utempter.h HAVE_UTEMPTER)
    if (HAVE_UTEMPTER)
        target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME} PRIVATE
                "HAVE_UTEMPTER"
        )
        target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME} ulog)
    endif()
endif()

if (UTF8PROC_FOUND)
    target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
        PRIVATE
            "HAVE_UTF8PROC"
    )
    target_include_directories(${TERMINALWIDGET_LIBRARY_NAME}
        INTERFACE
            ${UTF8PROC_INCLUDE_DIRS}
    )
    target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME}
        ${UTF8PROC_LIBRARIES}
    )
    string(APPEND PKG_CONFIG_REQ ", libutf8proc")
endif()

if(APPLE)
    set (CMAKE_SKIP_RPATH 1)
    # this is a must to load the lib correctly
    set_target_properties(${TERMINALWIDGET_LIBRARY_NAME} PROPERTIES INSTALL_NAME_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
endif()

target_compile_definitions(${TERMINALWIDGET_LIBRARY_NAME}
    PRIVATE
        "KB_LAYOUT_DIR=\"${KB_LAYOUT_DIR}\""
        "COLORSCHEMES_DIR=\"${COLORSCHEMES_DIR}\""
        "TRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\""
        "HAVE_POSIX_OPENPT"
        "HAVE_SYS_TIME_H"
)


generate_export_header(${TERMINALWIDGET_LIBRARY_NAME}
    EXPORT_FILE_NAME "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    EXPORT_MACRO_NAME TERMINALWIDGET_EXPORT
)

target_include_directories(${TERMINALWIDGET_LIBRARY_NAME}
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/lib>"
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/lib>"
    INTERFACE
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}>"
)

write_basic_package_version_file(
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config-version.cmake"
    VERSION ${TERMINALWIDGET_VERSION}
    COMPATIBILITY AnyNewerVersion
)

install(FILES
    "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-config-version.cmake"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)

install(EXPORT
    "${TERMINALWIDGET_LIBRARY_NAME}-targets"
    DESTINATION "${CMAKE_INSTALL_LIBDIR}/cmake/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)

install(FILES
    ${HDRS_DISTRIB} "${CMAKE_CURRENT_BINARY_DIR}/lib/qtermwidget_export.h"
    DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/${TERMINALWIDGET_LIBRARY_NAME}"
    COMPONENT Devel
)
# keyboard layouts
install(DIRECTORY
    lib/kb-layouts/
    DESTINATION "${KB_LAYOUT_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.keytab"
)
# color schemes
install(DIRECTORY
    lib/color-schemes/
    DESTINATION "${COLORSCHEMES_DIR}"
    COMPONENT Runtime
    FILES_MATCHING PATTERN "*.*schem*"
)

lxqt_create_pkgconfig_file(
    PACKAGE_NAME ${TERMINALWIDGET_LIBRARY_NAME}
    DESCRIPTIVE_NAME ${TERMINALWIDGET_LIBRARY_NAME}
    DESCRIPTION "TerminalWidget library for Qt ${TERMINALWIDGET_VERSION_MAJOR}.x"
    INCLUDEDIRS ${TERMINALWIDGET_LIBRARY_NAME}
    LIBS ${TERMINALWIDGET_LIBRARY_NAME}
    REQUIRES ${PKG_CONFIG_REQ}
    VERSION ${TERMINALWIDGET_VERSION}
    INSTALL
    COMPONENT Devel
)

install(TARGETS ${TERMINALWIDGET_LIBRARY_NAME}
    DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    EXPORT "${TERMINALWIDGET_LIBRARY_NAME}-targets"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    PUBLIC_HEADER
    COMPONENT Runtime
)

export(TARGETS ${TERMINALWIDGET_LIBRARY_NAME}
    FILE "${CMAKE_BINARY_DIR}/${TERMINALWIDGET_LIBRARY_NAME}-targets.cmake"
    EXPORT_LINK_INTERFACE_LIBRARIES
)
# end of main library

=== debian/changelog ===
deepin-terminal (5.4.28-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Mon, 17 Jan 2022 09:41:57 +0800

deepin-terminal (5.2.0) unstable; urgency=medium

  * Initial Release.

 -- Deepin Packages Builder <packages@deepin.com>  Mon, 13 Jan 2020 16:13:35 +0800

## deepin-terminal 5.4.33

=== CMakeLists.txt ===
--- 
+++ 
@@ -49,6 +49,12 @@
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
 
 configure_file(src/environments.h.in environments.h @ONLY)
+
+#代码覆盖率开关
+if(CMAKE_COVERAGE_ARG STREQUAL "CMAKE_COVERAGE_ARG_ON")
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -Wall -fprofile-arcs -ftest-coverage")
+endif()
 
 # Find the QtWidgets library
 
@@ -118,6 +124,7 @@
 set (DTNG_CPP_FILES
     src/common/utils.cpp
     src/common/settingio.cpp
+    src/common/eventlogutils.cpp
     src/customcommand/customcommandoptdlg.cpp
     src/customcommand/customcommandpanel.cpp
     src/customcommand/customcommandplugin.cpp
@@ -168,6 +175,7 @@
     src/common/define.h
     src/common/utils.h
     src/common/settingio.h
+    src/common/eventlogutils.h
     src/customcommand/customcommandoptdlg.h
     src/customcommand/customcommandpanel.h
     src/customcommand/customcommandplugin.h
@@ -281,3 +289,5 @@
 
 # Unit Test
 add_subdirectory(tests)
+
+

=== tests/CMakeLists.txt ===

project(deepin-terminal-test)

configure_file(../src/environments.h.in environments.h @ONLY)

# 设置添加gocv相关信息的输出
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fprofile-arcs -ftest-coverage -fno-inline")
#安全编译参数
set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(PROJECT_NAME_TEST ${PROJECT_NAME})

add_compile_options(-fno-access-control)

find_package(Qt5Test REQUIRED)
find_package(GTest REQUIRED)

add_definitions(${Qt5Test_DEFINITIONS})
add_definitions(-D UNIT_TEST)

include_directories(${GTEST_INCLUDE_DIRS})
include_directories("src/common")
include_directories("src/customcommand")
include_directories("src/encodeplugin")
include_directories("src/remotemanage")
include_directories("src/views")
include_directories("src/main")
include_directories("src/3rdparty/terminalwidget/lib/")
include_directories("src/3rdparty/terminalwidget/lib/history")
include_directories("src/3rdparty/terminalwidget/lib/history/compact")

FILE(GLOB allSource
    ../src/common/*.cpp
    ../src/customcommand/*.cpp
    ../src/encodeplugin/*.cpp
    ../src/remotemanage/*.cpp
    ../src/settings/*.cpp
    ../src/views/*.cpp
    ../src/main/service.cpp
    ../src/main/windowsmanager.cpp
    ../src/main/mainwindow.cpp
    ../src/main/terminalapplication.cpp
    ../src/main/termproperties.cpp
    ../src/main/dbusmanager.cpp
    ../src/main/atspidesktop.cpp
)

FILE(GLOB allHeaders
    ../src/common/*.h
    ../src/customcommand/*.h
    ../src/encodeplugin/*.h
    ../src/main/*.h
    ../src/remotemanage/*.h
    ../src/settings/*.h
    ../src/views/*.h
)

FILE(GLOB allThirdPartySource
    ../3rdparty/terminalwidget/lib/*.cpp
    ../3rdparty/terminalwidget/lib/history/*.cpp
    ../3rdparty/terminalwidget/lib/history/compact/*.cpp
)

FILE(GLOB qrcFiles
    ../src/assets/resources.qrc
)

FILE(GLOB allTestHeader
    src/common/*.h
    src/customcommand/*.h
    src/encodeplugin/*.h
    src/main/*.h
    src/remotemanage/*.h
    src/settings/*.h
    src/views/*.h
    src/3rdparty/terminalwidget/lib/*.h
)

FILE(GLOB allTestSource
    src/common/*.cpp
    src/customcommand/*.cpp
    src/encodeplugin/*.cpp
    src/main/*.cpp
    src/remotemanage/*.cpp
    src/settings/*.cpp
    src/views/*.cpp
)

set(UI ../3rdparty/terminalwidget/lib/SearchBar.ui)
qt5_wrap_ui(UI_SRCS ${UI})

set(KB_LAYOUT_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/kb-layouts")
set(COLORSCHEMES_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/color-schemes")
set(TRANSLATIONS_DIR "${CMAKE_INSTALL_FULL_DATADIR}/${TERMINALWIDGET_LIBRARY_NAME}/translations")

add_definitions("-DHAVE_POSIX_OPENPT")
add_definitions("-DKB_LAYOUT_DIR=\"${KB_LAYOUT_DIR}\"")
add_definitions("-DCOLORSCHEMES_DIR=\"${COLORSCHEMES_DIR}\"")
add_definitions("-DTRANSLATIONS_DIR=\"${TRANSLATIONS_DIR}\"")

add_executable(${PROJECT_NAME_TEST}
    ${UI_SRCS}
    ${allThirdPartySource}
    ${allHeaders}
    ${allSource}
    ${allTestHeader}
    ${allTestSource}
    ${qrcFiles}
    ${uiFiles}
)

target_include_directories(${PROJECT_NAME_TEST} PUBLIC ${Qt5Widgets_LIBRARIES}
                                                        ${Qt5DBus_LIBRARIES}
                                                        ${Qt5TestLib_LIBRARIES}
                                                        ${Qt5Widgets_PRIVATE_INCLUDE_DIRS}
                                                        ${Qt5Core_PRIVATE_INCLUDE_DIRS}
                                                        ${Qt5Gui_PRIVATE_INCLUDE_DIRS}
                                                        ${PROJECT_BINARY_DIR}
                                                        ${DtkWidget_INCLUDE_DIRS}
                                                        ${DtkCore_LIBRARIES}
                                                        ${DtkGUI_INCLUDE_DIRS}
                                                        ${DFrameworkDBus_INCLUDE_DIRS}
                                                        ${GOBJECT_INCLUDE_DIRS}
                                                        ${LIBSECRET_INCLUDE_DIRS})

target_link_libraries(${PROJECT_NAME_TEST} PUBLIC ${LINK_LIBS} Qt5::Test ${GTEST_LIBRARIES} ${GTEST_MAIN_LIBRARIES} -lpthread -lm)

#------------------------------ 创建'make test'指令---------------------------------------
add_custom_target(test
#    #执行mkdir -p 创建 coverageResult
#    COMMAND mkdir -p coverageResult
#    #设置工作目录
#    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}
)

add_custom_command(TARGET test
    COMMAND ${CMAKE_BINARY_DIR}/tests/${PROJECT_NAME_TEST}
)

#'make test'命令依赖与我们的测试程序
add_dependencies(test ${PROJECT_NAME_TEST})

#ASAN安全性检测标志
set(CMAKE_SAFETYTEST "${CMAKE_SAFETYTEST_ARG}")
if(CMAKE_SAFETYTEST STREQUAL "")
    set(CMAKE_SAFETYTEST "CMAKE_SAFETYTEST_ARG_OFF")
endif()

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -D${CMAKE_SAFETYTEST}")
if(CMAKE_SAFETYTEST STREQUAL "CMAKE_SAFETYTEST_ARG_ON")
  #安全测试选项
  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -g -fsanitize=undefined,address -O2")
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g -fsanitize=undefined,address -O2")
endif()

=== debian/changelog ===
deepin-terminal (5.4.33-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Fri, 12 Aug 2022 10:29:49 +0800

=== debian/control ===
Source: deepin-terminal
Section: utils
Priority: optional
Maintainer: Deepin Packages Builder <packages@deepin.org>
Build-Depends:
 debhelper(>= 11),
 cmake,
 pkg-config,
 qtbase5-dev,
 qttools5-dev-tools,
 qtbase5-private-dev,
 libdtkwidget-dev,
 libdframeworkdbus-dev,
 lxqt-build-tools(>= 0.6.0~),
 libutf8proc-dev,
 libglib2.0-dev,
 libsecret-1-dev,
 libgtest-dev,
 libgmock-dev,
 libxcb-ewmh-dev
Standards-Version: 4.5.1
Homepage: https://www.deepin.com/

Package: deepin-terminal
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 expect,
 zssh
Description: Terminal is an advanced terminal emulator with workspace, multiple
 windows, remote management, quake mode and other features.
 Terminal is a terminal emulator with simple interface, rich and powerful
 functions such as multi-windows, workspace, remote management, Quake mode
 and etc. You can instantly start and close Terminal smoothly like normal
 file window, allowing you to input commands with facility and no distractions.

## deepin-terminal 5.4.35

=== CMakeLists.txt ===
--- 
+++ 
@@ -43,7 +43,7 @@
 endif()
 
 #Use deepin-turbo for Performance optimization
-set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wl,--as-need -fPIE")
+set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wl,--as-needed -fPIE")
 set(CMAKE_EXE_LINKER_FLAGS "-pie")
 #安全编译参数
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")
@@ -288,6 +288,6 @@
         DESTINATION /usr/share/deepin-manual/manual-assets/application/)
 
 # Unit Test
+if (CMAKE_BUILD_TYPE MATCHES Debug)
 add_subdirectory(tests)
-
-
+endif()

=== debian/changelog ===
deepin-terminal (5.4.35-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 14 Sep 2022 15:49:55 +0800

## deepin-terminal 5.9.40

=== debian/changelog ===
deepin-terminal (5.9.40-1) unstable; urgency=medium

  * update

 -- Deepin Packages Builder <packages@deepin.org>  Wed, 04 Jan 2023 14:04:27 +0800

deepin-terminal (5.9.40) unstable; urgency=medium

  * New version 5.9.40

 -- hemingyang <hemingyang@uniontech.com>  Mon, 03 Jan 2023 11:23:05 +0800

## deepin-terminal 5.9.40+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 
 #Use deepin-turbo for Performance optimization
 set(CMAKE_CXX_FLAGS "${CMAKE_C_FLAGS} -Wl,--as-needed -fPIE")
-set(CMAKE_EXE_LINKER_FLAGS "-pie")
+set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -pie")
 #安全编译参数
 set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fstack-protector-strong -D_FORTITY_SOURCE=1 -z noexecstack -pie -fPIC -z lazy")

=== 3rdparty/terminalwidget/CMakeLists.txt ===
--- 
+++ 
@@ -76,9 +76,6 @@
     lib/history/HistoryType.cpp
     lib/history/HistoryTypeFile.cpp
     lib/history/HistoryTypeNone.cpp
-    lib/history/compact/CompactHistoryBlock.cpp
-    lib/history/compact/CompactHistoryBlockList.cpp
-    lib/history/compact/CompactHistoryLine.cpp
     lib/history/compact/CompactHistoryScroll.cpp
     lib/history/compact/CompactHistoryType.cpp
     lib/HistorySearch.cpp
@@ -101,6 +98,7 @@
     lib/TerminalDisplay.cpp
     lib/tools.cpp
     lib/Vt102Emulation.cpp
+    lib/EscapeSequenceUrlExtractor.cpp
 )
 
 # Only the Headers that need to be moc'd go here
@@ -114,9 +112,6 @@
     lib/history/HistoryType.h
     lib/history/HistoryTypeFile.h
     lib/history/HistoryTypeNone.h
-    lib/history/compact/CompactHistoryBlock.h
-    lib/history/compact/CompactHistoryBlockList.h
-    lib/history/compact/CompactHistoryLine.h
     lib/history/compact/CompactHistoryScroll.h
     lib/history/compact/CompactHistoryType.h
     lib/HistorySearch.h
@@ -132,6 +127,7 @@
     lib/SessionManager.h
     lib/TerminalDisplay.h
     lib/Vt102Emulation.h
+    lib/EscapeSequenceUrlExtractor.h
 )
 
 set(UI
@@ -152,9 +148,6 @@
     lib/history/HistoryType.h
     lib/history/HistoryTypeFile.h
     lib/history/HistoryTypeNone.h
-    lib/history/compact/CompactHistoryBlock.h
-    lib/history/compact/CompactHistoryBlockList.h
-    lib/history/compact/CompactHistoryLine.h
     lib/history/compact/CompactHistoryScroll.h
     lib/history/compact/CompactHistoryType.h
     lib/BlockArray.h

=== debian/changelog ===
deepin-terminal (5.9.40+dfsg-4build1) plucky; urgency=medium

  * No-change rebuild for lxqt-build-tools C++17 -> C++20.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 03 Jan 2025 03:51:38 -0600

deepin-terminal (5.9.40+dfsg-4) unstable; urgency=medium

  * Add patch to use lxqt2-build-tools.
  * debian/control:
    + Add qt6-tools-dev to Build-Depends.
    + Tighten Build-Depends lxqt-build-tools to (>= 2.0.0~).
    + Replace Build-Depends pkg-config to pkgconf.

 -- Arun Kumar Pariyar <arun@debian.org>  Wed, 27 Nov 2024 22:17:37 +0545

deepin-terminal (5.9.40+dfsg-3) unstable; urgency=medium

  * Add qttools5-dev to Build-Deps (Closes: #1078279).

 -- Arun Kumar Pariyar <arun@debian.org>  Mon, 16 Sep 2024 00:47:32 +0545

deepin-terminal (5.9.40+dfsg-2) unstable; urgency=medium

  [ Arun Kumar Pariyar ]
  * debian/patches:
    + Add 0003-avoid-regeneration-of-ts-files.patch (Closes: #1044857).

  [ Dmitry Shachnev ]
  * Backport upstream fix to not overwrite CMAKE_CXX_FLAGS by CMAKE_C_FLAGS.
    Closes: #1066406.

 -- Arun Kumar Pariyar <arun@debian.org>  Mon, 08 Apr 2024 00:12:37 +0545

deepin-terminal (5.9.40+dfsg-1) unstable; urgency=medium

  * New upstream version 5.9.40+dfsg. (Closes: #1028611)
  * debian/patches:
    + Drop 0003-remove-definitions-DQT_NO_CAST_FROM_ASCII-DQT_NO_CAS.patch
  * Update lintian-overrides.
  * debian/control:
    + Bump Standards-Version to 4.6.2.
    + Add packages libgmock-dev, libgtest-dev, libsecret-1-dev, and
      libxcb-ewmh-dev to B-D.
    + Drop libatspi2.0-dev and chrpath from B-D.
  * debian/copyright: Refresh copyright information.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Arun Kumar Pariyar <arun@debian.org>  Thu, 23 Feb 2023 17:48:17 +0545

=== debian/control ===
Source: deepin-terminal
Section: x11
Priority: optional
Maintainer: Debian Deepin Packaging Team <pkg-deepin-devel@lists.alioth.debian.org>
Uploaders:
 Yanhao Mo <yanhaocs@gmail.com>,
 Boyuan Yang <byang@debian.org>,
 Arun Kumar Pariyar <arun@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libdframeworkdbus-dev (>= 5.4.20~),
 libdtkwidget-dev (>= 5.5.17~),
 libglib2.0-dev,
 libgmock-dev,
 libgtest-dev,
 libsecret-1-dev,
 libutf8proc-dev,
 libxcb-ewmh-dev,
 lxqt-build-tools (>= 2.0.0~),
 pkgconf,
 qt5-qmake,
 qt6-tools-dev,
 qtbase5-dev,
 qtbase5-private-dev,
 qttools5-dev,
 qttools5-dev-tools,
Rules-Requires-Root: no
Standards-Version: 4.6.2
Homepage: https://github.com/linuxdeepin/deepin-terminal
Vcs-Git: https://salsa.debian.org/pkg-deepin-team/deepin-terminal.git
Vcs-Browser: https://salsa.debian.org/pkg-deepin-team/deepin-terminal

Package: deepin-terminal
Architecture: any
Provides:
 x-terminal-emulator,
Depends:
 expect,
 zssh,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Deepin terminal emulator application
 Deepin Terminal is an advanced terminal emulator with workspace, multiple
 windows, remote management, quake mode and other features. It sharpens your
 focus in the world of command line.
 .
 This package is part of DDE (Deepin Desktop Environment).

## deepin-terminal 5.9.51%2Bdfsg

=== debian/changelog ===
deepin-terminal (5.9.51+dfsg-1.1build3) resolute; urgency=medium

  * No-change rebuild against Qt 5.15.18 on amd64v3.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 18 Jan 2026 10:26:20 +0300

deepin-terminal (5.9.51+dfsg-1.1build2) resolute; urgency=medium

  * No-change rebuild against Qt 5.15.18.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Wed, 14 Jan 2026 20:02:00 +0300

deepin-terminal (5.9.51+dfsg-1.1build1) resolute; urgency=medium

  * No-change rebuild for icu soname.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 03 Dec 2025 14:37:44 +0100

deepin-terminal (5.9.51+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1112836)

 -- Adrian Bunk <bunk@debian.org>  Sat, 11 Oct 2025 18:23:53 +0300

deepin-terminal (5.9.51+dfsg-1) unstable; urgency=medium

  * New upstream release. (Closes: #1096235)
  * debian/control: Add new build-dep.
  * debian/patches/0004: Refreshed.

 -- Boyuan Yang <byang@debian.org>  Mon, 17 Feb 2025 16:43:15 -0500

## deepin-terminal 5.9.51+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -66,7 +66,7 @@
 find_package(Qt5LinguistTools REQUIRED)
 find_package(Qt5Network REQUIRED)
 find_package(Qt5X11Extras REQUIRED)
-#find_package(DtkWidget REQUIRED)
+find_package(DtkWidget REQUIRED)
 #find_package(DtkCore REQUIRED)
 #find_package(DtkGui REQUIRED)
 
@@ -286,6 +286,25 @@
 
 install(DIRECTORY src/assets/deepin-terminal
         DESTINATION /usr/share/deepin-manual/manual-assets/application/)
+message("CMAKE_INSTALL_PREFIX: " ${CMAKE_INSTALL_PREFIX})
+#安装日志调试模式配置文件
+install(FILES src/assets/config/debugconfig/org.deepin.terminal.json
+        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-debug-config/deepin-debug-config.d/)
+#install(FILES src/assets/config/debugconfig/deepin-terminal_debug.sh
+#        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-debug-config/shell/)
+#安装DConfig配置
+set(APPID org.deepin.terminal)
+set(configFile ${PROJECT_SOURCE_DIR}/src/assets/config/dconfig/org.deepin.terminal.json)
+if (DEFINED DSG_DATA_DIR)
+    message("-- DConfig is supported by DTK")
+    dconfig_meta_files(APPID ${APPID} FILES ${configFile})
+else()
+    message("-- DConfig is not supported by DTK")
+    install(FILES ${configFile} DESTINATION ${CMAKE_INSTALL_PREFIX}/share/dsg/config/org.deepin.terminal/)
+endif()
+#安装日志收集工具配置文件
+install(FILES src/assets/config/logconfig/org.deepin.terminal.json
+        DESTINATION ${CMAKE_INSTALL_PREFIX}/share/deepin-log-viewer/deepin-log.conf.d/)
 
 # Unit Test
 if (CMAKE_BUILD_TYPE MATCHES Debug)

=== tests/CMakeLists.txt ===
--- 
+++ 
@@ -1,3 +1,6 @@
+# SPDX-FileCopyrightText: 2022 UnionTech Software Technology Co., Ltd.
+#
+# SPDX-License-Identifier: GPL-3.0-or-later
 
 project(deepin-terminal-test)

=== 3rdparty/terminalwidget/CMakeLists.txt ===
--- 
+++ 
@@ -11,6 +11,12 @@
 include(CMakePackageConfigHelpers)
 include(CheckFunctionExists)
 include(CheckIncludeFile)
+link_libraries(uchardet)
+link_libraries(chardet)
+
+pkg_check_modules(chardet REQUIRED chardet)
+include_directories(${chardet_INCLUDE_DIRS})
+link_directories(${chardet_LIBRARY_DIRS})
 
 option(UPDATE_TRANSLATIONS "Update source translation translations/*.ts files" OFF)
 option(BUILD_EXAMPLE "Build example application. Default OFF." OFF)
@@ -39,6 +45,7 @@
 find_package(Qt5Widgets "${QT_MINIMUM_VERSION}" REQUIRED)
 find_package(Qt5LinguistTools "${QT_MINIMUM_VERSION}" REQUIRED)
 find_package(lxqt-build-tools ${LXQTBT_MINIMUM_VERSION} REQUIRED)
+find_package(ICU COMPONENTS i18n uc REQUIRED)
 
 if(USE_UTF8PROC)
     find_package(Utf8Proc REQUIRED)
@@ -99,6 +106,7 @@
     lib/tools.cpp
     lib/Vt102Emulation.cpp
     lib/EscapeSequenceUrlExtractor.cpp
+    lib/encodes/detectcode.cpp
 )
 
 # Only the Headers that need to be moc'd go here
@@ -128,6 +136,7 @@
     lib/TerminalDisplay.h
     lib/Vt102Emulation.h
     lib/EscapeSequenceUrlExtractor.h
+    lib/encodes/detectcode.h
 )
 
 set(UI
@@ -187,7 +196,14 @@
 )
 
 add_library(${TERMINALWIDGET_LIBRARY_NAME} SHARED ${SRCS} ${MOCS} ${UI_SRCS} ${TERMINALWIDGET_QM})
-target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME} Qt5::Widgets)
+target_link_libraries(${TERMINALWIDGET_LIBRARY_NAME}
+    Qt5::Widgets
+    ICU::i18n
+    ICU::uc
+    -lm
+    uchardet
+    chardet
+    )
 if (USE_TEST)
     #仅在单元测试模式下设置fvisibility为default
     target_compile_options(${TERMINALWIDGET_LIBRARY_NAME} PUBLIC "-fvisibility=default")

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic

export QT_SELECT := 5

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

include /usr/share/dpkg/default.mk

%:
	dh $@

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -l/usr/lib

override_dh_auto_configure:
	dh_auto_configure -- \
	-DCMAKE_BUILD_TYPE=Release \
	-DCMAKE_INSTALL_PREFIX=/usr \
	-DAPP_VERSION=$(DEB_VERSION_UPSTREAM) \
	-DVERSION=$(DEB_VERSION_UPSTREAM) \
	LIB_INSTALL_DIR=/usr/lib/$(DEB_HOST_MULTIARCH)
